package com.brilliance.isc.transfer.transaction;

import com.brilliance.isc.bo.lg.GctpfrStoreBo;
import com.brilliance.isc.transfer.IBaseStructMapper;
import com.brilliance.isc.transfer.model.*;
import com.brilliance.isc.vo.lg.GctpfrStoreVo;
import org.mapstruct.*;
import org.mapstruct.factory.Mappers;

@Mapper(componentModel = "spring",uses = {
        IGctMapper.class, IGitMapper.class,
        INitMapper.class, INctMapper.class, IOtherModMapper.class}
)
public interface GctpfrStructMapper extends IBaseStructMapper<GctpfrStoreBo, GctpfrStoreVo> {
    /**
     * 此行语句一定要写，StructMapper需要
     */
    GctpfrStructMapper INSTANCE = Mappers.getMapper(GctpfrStructMapper.class);

    /**
     * Vo转为Bo
     *
     * @param vo
     * @return 返回业务Bo
     */
    @Override
    GctpfrStoreBo voTransferToBo(GctpfrStoreVo vo);

    /**
     * Vo追加更新至Bo
     * 忽略oldgrp的复制
     * @param vo
     * @param bo
     */
    @Override
    @Mappings({
            @Mapping(target = "gidgrp",ignore = true),
            @Mapping(target = "gcdgrp",ignore = true)
    })
    void voUpdateToBo(GctpfrStoreVo vo, @MappingTarget GctpfrStoreBo bo);

    @AfterMapping
    default void afterUpdate(GctpfrStoreVo vo, @MappingTarget GctpfrStoreBo bo){
        if (vo.getGcdgrp().getRec() != null){
            bo.getGcdgrp().getRec().setDemstat(vo.getGcdgrp().getRec().getDemstat());
            bo.getGcdgrp().getRec().setNewexpdat(vo.getGcdgrp().getRec().getNewexpdat());
        }
        if (vo.getGcdgrp().getBlk() != null){
            bo.getGcdgrp().getBlk().setAddamtinf(vo.getGcdgrp().getBlk().getAddamtinf());
            bo.getGcdgrp().getBlk().setPresentdet(vo.getGcdgrp().getBlk().getPresentdet());
        }
        bo.getGcdgrp().setTmpint(vo.getGcdgrp().getTmpint());
        bo.getGcdgrp().setAwi(vo.getGcdgrp().getAwi());
    }

    /**
     * Bo转为Vo
     *
     * @param bo
     * @return 返回Vo
     */
    @Override
    GctpfrStoreVo boTransferToVo(GctpfrStoreBo bo);

    /**
     * bo追加更新至Bo
     *
     * @param bo
     * @param vo
     */
    @Override
    void boUpdateToVo(GctpfrStoreBo bo, @MappingTarget GctpfrStoreVo vo);
}
